#include <stdlib.h>
#include <string.h>

#include <unistd.h>

static void
dpprintf(const char *format, ...)
{
  va_list	list;

  fprintf(stderr, "[");
  va_start(list, format);
  vfprintf(stderr, format, list);
  va_end(list);
  fprintf(stderr, "]\n");
  fflush(stderr);
}
#define xDP(X)	do { } while (0)
#define fDP(X)	do { dpprintf X; } while (0)
#if 1
#define DP(X)	do { } while (0)
#else
#include <stdarg.h>
#define DP(X)	do { dpprintf X; } while (0)
#endif

#if 0
static void
ex(const char *s)
{
  perror(s);
  fflush(stderr);
  exit(2);
}
#else
static void
ex(const char *);
#endif

static void *
re_alloc(void *buf, size_t len)
{
  if (!len)
    len	= 1;
  if ((buf=(buf ? realloc(buf, len) : malloc(len)))==NULL)
    ex("malloc");
  return buf;
}

static void *
alloc(size_t len)
{
  return re_alloc(NULL, len);
}

static char *
str_alloc(const char *s)
{
  size_t	len;
  char		*buf;

  len	= strlen(s)+1;
  buf	= re_alloc(NULL, len);
  strncpy(buf, s, len);
  buf[len-1]	= 0;
  return buf;
}
